package dev.shadowsoffire.apotheosis.adventure.boss;

import net.minecraft.world.entity.Mob;
import net.minecraft.core.BlockPos;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.server.level.ServerLevel;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.function.Predicate;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.item.context.UseOnContext;
import net.minecraft.world.item.Item;

public class BossSummonerItem extends Item
{
    public BossSummonerItem(final Item.Properties properties) {
        super(properties);
    }
    
    public InteractionResult m_6225_(final UseOnContext ctx) {
        final Level world = ctx.m_43725_();
        if (world.f_46443_) {
            return InteractionResult.SUCCESS;
        }
        final Player player = ctx.m_43723_();
        final ApothBoss item = (ApothBoss)BossRegistry.INSTANCE.getRandomItem(world.m_213780_(), ctx.m_43723_().m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches(world), GameStagesCompat.IStaged.matches(player) });
        if (item == null) {
            return InteractionResult.FAIL;
        }
        BlockPos pos = ctx.m_8083_().m_121945_(ctx.m_43719_());
        if (!world.m_45772_(item.getSize().m_82338_(pos))) {
            pos = pos.m_7494_();
            if (!world.m_45772_(item.getSize().m_82338_(pos))) {
                return InteractionResult.FAIL;
            }
        }
        final Mob boss = item.createBoss((ServerLevelAccessor)world, pos, world.m_213780_(), player.m_36336_());
        boss.m_6710_((LivingEntity)player);
        ((ServerLevel)world).m_47205_((Entity)boss);
        ctx.m_43722_().m_41774_(1);
        return InteractionResult.SUCCESS;
    }
}
